=== debian/changelog ===
osgearth (2.9.0+dfsg-3) unstable; urgency=medium

  * Drop autopkgtest to test installability.
  * Add lintian override for testsuite-autopkgtest-missing.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 01 Aug 2018 08:55:54 +0200

osgearth (2.9.0+dfsg-2) unstable; urgency=medium

  * Update Vcs-* URLs for Salsa.
  * Bump Standards-Version to 4.1.5, no changes.
  * Drop obsolete get-orig-source target.
  * Strip trailing whitespace from control & rules files.
  * Remove documentation outside usr/share/doc.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 20 Jul 2018 22:53:12 +0200
